parameters:
    knp_menu.renderer.twig.options:
        currentClass: "active"

services:
    Twig_Extension_StringLoader:
        class: Twig_Extension_StringLoader
        tags:
            - { name: twig.extension }

    # asset version strategy
    Datatourisme\Bundle\WebAppBundle\Asset\VersionStrategy\GulpBusterVersionStrategy:
        arguments:
            - "%kernel.project_dir%/busters.json"
        public: false

    # util monolog formatter
    webapp.monolog.exception.formatter:
        class: Monolog\Formatter\LineFormatter
        calls:
            - [includeStacktraces]

    # menu uri prefix voter
    webapp.menu_uri_prefix_voter:
        class: Datatourisme\Bundle\WebAppBundle\Menu\Matcher\Voter\UriPrefixVoter
        public: false
        tags:
            - { name: knp_menu.voter, request: true }

    # filterable paginated list factory
    webapp.filterable_paginated_list_factory:
        class: Datatourisme\Bundle\WebAppBundle\Pagination\FilterablePaginatedListFactory
        arguments: ["@form.factory", "@knp_paginator", "@lexik_form_filter.query_builder_updater"]

    # strong password validator
    webapp.strong_password_validator:
        class: Datatourisme\Bundle\WebAppBundle\Validator\Constraints\StrongPasswordValidator
        arguments: ["@security.token_storage", "@security.encoder_factory"]
        tags:
            - { name: validator.constraint_validator }

    # password encoder subscriber
    webapp.password_encoder_subscriber:
        class: Datatourisme\Bundle\WebAppBundle\EventListener\PasswordEncoderSubscriber
        arguments: ["@security.encoder_factory"]
        tags:
            - { name: doctrine.event_subscriber, connection: default }

    # mailer
    webapp.mailer:
        class: Datatourisme\Bundle\WebAppBundle\Mailer\Mailer
        arguments: ["@mailer", "@twig", "@translator", "@router.request_context", "%datatourisme_web_app.mailer.emails%"]
        calls:
            - [ setSender, ["%datatourisme_web_app.mailer.sender_address%", "%datatourisme_web_app.mailer.sender_name%"] ]
            - [ setSubjectTemplate, ["%datatourisme_web_app.mailer.subject_template%"] ]

    # repository : user
    webapp.repository.user:
        class: Datatourisme\Bundle\WebAppBundle\Repository\UserRepository
        abstract:  true
        factory:    ['@doctrine.orm.entity_manager', 'getRepository']
        calls:
            - [ setHierarchy, ['%security.role_hierarchy.roles%'] ]